=== debian/changelog ===
gnuradio (3.10.4.0-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Drop unused B-D: python3-sphinx. (Closes: #1023234)

  [ A. Maitland Bottoms ]
  * update to v3.10.4.0-87-g4c9e53e27
    more fixes for more passing tests on other than amd64

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 19 Nov 2022 10:42:12 -0500

gnuradio (3.10.4.0-3) unstable; urgency=medium

  * update to v3.10.4.0-17-gcfcd070f9
  * enable all tests again
  * re-enable building with thrift

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 25 Oct 2022 20:03:42 -0400

gnuradio (3.10.4.0-2) unstable; urgency=medium

  * remove -DENABLE_CTRLPORT_THRIFT=ON, since it is not available on all
    architectures. Bopefully fix FTBFS on mips*, ppc64el, s390x

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Sep 2022 22:55:27 -0400

gnuradio (3.10.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Replace `get_initial_sptr()` calls with `make_block_sptr()`
    calls. There were a number of places the incorrect function was being
    used.
  * Runtime
  - Use correctly typed arguments to log messages to prevent build errors.
  * GRC
  - Add xfce4-terminal and urxvt to the list of terminal emulators
    discovered during the build process.
  - Suppress GUI hint errors that were being shown in the terminal window.
  - Use integers for screenshot size (floats were causing Cairo errors).
  * Build system and packaging
  - Reformat cmake files and make cmake formatting part of the workflow.
  - Allow GNU Radio to be a part of other cmake-based projects.
  * gr-blocks
  - New Block Interleaver/Deinterleaver interleaves blocks of symbols
  - Correct calculation of `items_remaining` in File Source, which allows
    `seek()` to work correctly. 
  - Add an example for Wavefile Sink
  * gr-digital
  - Deprecate the CRC32 and CRC16 blocks, which will be removed in the
    future. There are more general CRC blocks which do the same thing (and
    more).
  * gr-filter
  - Fix demo for PFB channelizer
  * gr-iio
  - FMCOMMS2 Sink assumes CS16 data is scaled to 32768, rather than 2048.
  - FMCOMMS2 returns the correct samples for the second channel in
    2-channel mode.
  * gr-trellis
  - Correct Python bindings for `trellis::metrics`.
  * gr-qtgui
  - Range widget can now output messages when value changes.
  - Add C++ code generation for Time Sink
  - Regenerate Python bindings for some blocks when necessary.
  - Waterfall Sink correctly uses half spectrum for float input.
  * gr-uhd
  - Add Python bindings for the UHD `find()` functino.
  * gr-zeromq
  - Support newer `get()` and older/deprecated `getsockopt()` functions in
    cppzmq depending on availability.
  * Modtool
  - Parse IO signatures with or without `gr::` prefix.
  * Documentation
  - Update certain file lists to keep build paths out of documentation.
  
 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 16 Sep 2022 18:51:58 -0400

gnuradio (3.10.4.0~rc1-1) experimental; urgency=medium

  * New upstream release
  * Upload to emaperimental for ABI bump

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 13 Sep 2022 22:32:21 -0400

gnuradio (3.10.3.0-5) unstable; urgency=medium

  * include vowstar Fix build failures with libfmt-9.0.0

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 21 Aug 2022 08:30:03 -0400
